unit MLgrf;  {marek laco 13. februar 1997 - stvrtok - zalozeny}
             { 06.07.1997 - nedela, upravene o OOP}
             { 07.07.1997}

{ pre pracu v grafickom mode}

interface

  uses
    MLdos, spx_vga, graph;

  const
    FigureColor = 255;


  type
   _X = 0..1023;  {suradnica x - svga}
   _Y = 0..767;   {suradnica y - svga}
   _sur = record
                X: _X;
                Y: _Y;
              end;


   Figure = object
              X: _X;
              Y: _Y;
              Visible: boolean;
              Color: byte;
              constructor Init(InitX: _X; InitY: _Y; InitColor: byte);
              function GetX: _X;
              function GetY: _Y;
              function IsVisible: boolean;
              procedure Status(var StatusX: _X; var StatusY: _Y;
                               var StatusColor: byte);
              procedure Draw; virtual;
              procedure Show;
              procedure Hide;
              procedure MoveTo(NewX: _X; NewY: _Y);
           end;

  _Bod = object(Figure)
           procedure Draw; virtual;
         end;

  _Line = object(Figure)
            dX: _X;
            dY: _Y;
            constructor Init(InitX: _X; InitY: _Y; InitdX: _X; InitdY: _Y; InitColor: byte);
            procedure Draw; virtual;
            function GetdX: _X;
            function GetdY: _Y;
            procedure Status(var StatusX: _X; var StatusY: _Y;
                             var StatusdX: _X; var StatusdY: _Y;
                             var StatusColor: byte);
            procedure MoveTo(NewX: _X; NewY: _Y; NewdX: _X; NewdY: _Y);
          end;


  procedure SVGA1024; {inicializuje gr. mod 256 farieb, vesa}
  procedure SVGA800; {inicializuje gr. mod 256 farieb, vesa}
  procedure SVGA640; {inicializuje gr. mod 256 farieb, vesa}
  procedure LoadPal(F_Name: string); {loadne vga256 paletu zo suboru}
  procedure SavePal(F_Name: string); {sejvne vga256 paletu do suboru}
  procedure TextDoStredu(Y: _Y; St: string);
  {napise text, aby bol vycentrovany na stred x}
  procedure Vymaz(X1, Y1, X2, Y2, C: integer);
  {ako BAR() a sete aj farba}
  procedure RamcekStred(XStred: _X; Y1, Y2: _Y; Color, Sirka: byte; Fill: integer);
  {ramcek}
  procedure OutTextXYpoZ(X, Y, Pozadie: integer; Text: string);
  {napise text, pod nim ale bude pozadie, ake zadas}



implementation

{--------------------------------}

constructor Figure.Init(InitX: _X; InitY: _Y; InitColor: byte);
begin
  X := InitX;
  Y := InitY;
  Color := InitColor;
  Visible := FALSE;
end;


function Figure.GetX: _X;
begin
  GetX := X;
end;


function Figure.GetY: _Y;
begin
  GetY := Y;
end;



function Figure.IsVisible: boolean;
begin
  IsVisible := Visible
end;

procedure Figure.Status(var StatusX: _X; var StatusY: _Y; var StatusColor: byte);
begin
  StatusX := X;
  StatusY := Y;
  StatusColor := Color
end;

procedure Figure.Draw;
begin
end;

procedure Figure.Show;
begin
  Visible := TRUE;
  SetColor(Color);
  Draw;
end;

procedure Figure.Hide;
begin
  Visible := FALSE;
  SetColor(GetBkColor);
  Draw;
end;


procedure Figure.MoveTo(NewX: _X; NewY: _Y);
var Zobrazene: boolean;
begin
  Zobrazene := Visible;
  if Zobrazene then Hide;
  X := NewX;
  Y := NewY;
  if Zobrazene then Show;
end;

{-------------------------------------}

procedure _Bod.Draw;
begin
  PutPixel(X, Y, GetColor);
end;


{-----------------------------------------}

constructor _Line.Init(InitX: _X; InitY: _Y; InitdX: _X; InitdY: _Y; InitColor: byte);
begin
  Figure.Init(InitX, InitY, InitColor);
  dX := InitdX;
  dY := InitdY;
end;


procedure _Line.Draw;
begin
  Line(X, Y, dX, dY);
end;

function _Line.GetdX: _X;
begin
  GetdX := dX;
end;

function _Line.GetdY: _Y;
begin
  GetdY := dY;
end;


procedure _Line.Status(var StatusX: _X; var StatusY: _Y;
                             var StatusdX: _X; var StatusdY: _Y;
                             var StatusColor: byte);
begin
  StatusX := X;
  StatusY := Y;
  StatusdX := dX;
  StatusdY := dY;
  StatusColor := Color;
end;


procedure _Line.MoveTo(NewX: _X; NewY: _Y; NewdX: _X; NewdY: _Y);
var Zobrazene: boolean;
begin
  Zobrazene := Visible;
  if Zobrazene then Hide;
  X := NewX;
  Y := NewY;
  dX := NewdX;
  dY := NewdY;
  if Zobrazene then Show;
end;


{-----------------------------------------}


procedure SVGA1024;
var a,b:integer;
begin
  A:=InstallUserDriver('SVGA256', nil);
  B := 4;  {1024*768}
  InitGraph(A, B, '');
end;

procedure SVGA800;
var a,b:integer;
begin
  A:=InstallUserDriver('SVGA256', nil);
  B := 3;  {800*600}
  InitGraph(A, B, '');
end;

procedure SVGA640;
var a,b:integer;
begin
  A:=InstallUserDriver('SVGA256', nil);
  B := 2;  {640*480}
  InitGraph(A, B, '');
end;


{-------------------------------------}


procedure LoadPal(F_Name: string);
var RGB_f: file of RGBlist;
    RGB: RGBlist;
begin
  if not FileExist(F_Name) then Abord('Subor ' + F_Name + ' njeje');
  Assign(RGB_f, F_Name);
  Reset(RGB_f);
  Read(RGB_f, RGB);
  Close(RGB_f);
  fSetColors(RGB);
end;

procedure SavePal(F_Name: string);
var RGB_f: file of RGBlist;
    RGB: RGBlist;

begin
  fgetcolors(rgb);
  assign(rgb_f, F_Name);
  rewrite(rgb_f);
  write(rgb_f, rgb);
  close(rgb_f);
end;


{-------------------------------------}


procedure TextDoStredu(Y: _Y; St: string);
begin
  OutTextXY((GetMaxX - TextWidth(St)) div 2, Y, St);
end;



{-------------------------------------}


procedure Vymaz(X1, Y1, X2, Y2, C: integer);
begin
  SetFillStyle(1, C);
  Bar(X1, Y1, X2, Y2);
end;


{-------------------------------------}


procedure RamcekStred(XStred: _X; Y1, Y2: _Y; Color, Sirka: byte; Fill: integer);
{ak Fill < 0 then fill sa nekona'}
begin
  if Fill >= 0 then
    Vymaz((GetMaxX div 2) - Xstred, Y1, (GetMaxX div 2) + XStred, Y2, Fill);
  SetColor(Color);
  SetLineStyle(0, 0, Sirka);
  Rectangle((GetMaxX div 2) - XStred, Y1, (GetMaxX div 2) + XStred, Y2);
end;


{-------------------------------------}


procedure OutTextXYpoZ(X, Y, Pozadie: integer; Text: string);
begin
  Vymaz(X - 1, Y - 1, X + TextWidth(Text) + 1, Y + TextHeight(Text) + 1, Pozadie);
  OutTextXY(X, Y, Text);
end;


end.



